//Custom mob spawning pattern by Sin0psysS
//You are allowed to copy this code in your mods, and use it even without giving me credit
//Just tell me if and I helped you and give me credits, if you want to!
//Read ALL the notes carefully or you won't understand a thing.


var alea;
var unstuck=-1
var time;
var yourMob; //Change this to your mob's name in all the code
var spawned=0;
var pitch;
var yaw;
var orX;
var orY;

function modTick()
{
alea=Math.floor((Math.random()*1000)+1);

//Change probability here (the 1000 value) ; 1000 is for balanced spawn.

//Right here is the day/night check. Here, it is set to spawn at night only. Remove the lines ended by # if your mob can spawn at any time ; put the code in the else marqued by * in the if(time<(19200/2)) to allow spawn at day only.

time = Level.getTime()-Math.floor(Level.getTime()/19200)*19200; //#
if(time<(19200/2)) //#
{ //#
} //#
else //# *
{ //#
if(spawned==0&&alea==1)

//The spawned check is to make sure your mob will only spawn one at a time (if it has special behavior or drops that require a hook)
//remove it if it has no special behavior and drops (only a texture and render type for example) which will allow several to spawn at a time.

{
//The following 4 lines are to make sure your mob will never spawn in front of the player.

pitch = ((Entity.getPitch(getPlayerEnt()) + 90) * Math.PI)/180;
yaw = ((Entity.getYaw(getPlayerEnt()) + 90) * Math.PI)/180;
orX = Math.sin(pitch) * Math.cos(yaw);
orZ = Math.sin(pitch) * Math.sin(yaw);

yourMob = Level.spawnMob(getPlayerX()-(25*orX), getPlayerY(), getPlayerZ()-(25*orZ), 32, "mob/dantdm.png");
clientMessage("DanTDM joined the game");

//Change the 20 value to make your mob spawn closer or not from the player.

spawned=1;
Entity.setHealth(yourMob,50)
Entity.setNameTag(yourMob, "DanTDM")
//Define your mob here : change id, texture, render type, health...
unstuck=20; 

//This activates the unstuck system for one second for your mob. This way even if it spawns in a block it'll go back to surface almost instantly.
//This way you don't have to make your mob spawn too high, making it take fall damages, which is not swag.

}
} //#

//The following code is when the unstuck system is activated (during one second after spawn)

if(unstuck>=1)
{
unstuck=unstuck-1;
if(getTile(Entity.getX(yourMob),Entity.getY(yourMob), Entity.getZ(yourMob))==0)
{
}
else
{
setPosition(Entity.getX(yourMob),Entity.getY(yourMob)+1,Entity.getZ(yourMob))
}
}
if(unstuck==0)
{
unstuck=-1;
}

//This is useful only if your mob spawns one at a time : if you go too far from it (probably didn't see it) it is removed, so as another to spawn closer to the player.

if(Player.getX()-Entity.getX(yourMob)<=-50||Player.getX()-Entity.getX(yourMob)>=50||Player.getZ()-Entity.getZ(yourMob)<=-50||Player.getZ()-Entity.getZ(yourMob)>=50)
{
spawned=0;
Entity.remove(yourMob);
}
}

//This allows your custom mob to drop custom loots.
//Again, this is only useful if your mob spawns one at a time : else only the last spawned will drop the loots.
function deathHook(murderer, victim)
{
if(victim==yourMob)
{ Level.dropItem(Entity.getX(victim), Entity.getY(victim), Entity.getZ(victim), 3, 264, 1, 0)
spawned=0;

}
}